// SetPRPMode.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <windows.h>
#include <TlHelp32.h>
#include "mxprp.h"

bool CheckMxPrpService();

#define LED_INDEX_PRP 0

/*****************************************************************/
int _tmain(int argc, _TCHAR* argv[])
{
	int boardIndex = 0;
	int ledIndex = LED_INDEX_PRP;
	UINT8 slaveAddr = 0x0;
	bool isServiceExist = false; 

	isServiceExist = CheckMxPrpService();
	if(isServiceExist==true)
	{
		printf("mxPrpService is running, to run this program, please stop the mxPrpService\n");
		printf("Exit the program\n");
		return 0;
	}

	if(argc < 2)
	{
		/* Get user selection for smbus slave address */
		printf("Enter the boardIndex:\n");
		scanf("%d", &boardIndex);
	}
	else
	{
		boardIndex = _wtol(argv[1]);
	}

	slaveAddr = SMBUS_SLAVE_ADDRESS
	slaveAddr += (UINT8)boardIndex;

	/* Set the PRP mode */
	SetPrpMode(slaveAddr);

	/* Set the link mode */
	SetLinkSpeedMode(slaveAddr);

	/* Set the module led*/
	ConfigureGpioMode(slaveAddr, ledIndex);
	SetLedValue(slaveAddr, ledIndex);

	return 0;
}

bool CheckMxPrpService()
{
	WCHAR* name = L"MxPrpSvc.exe";

	HANDLE SnapShot = CreateToolhelp32Snapshot( TH32CS_SNAPPROCESS, 0 );

	if( SnapShot == INVALID_HANDLE_VALUE )
		return false;

	PROCESSENTRY32 procEntry;
	procEntry.dwSize = sizeof( PROCESSENTRY32 );

	if( !Process32First( SnapShot, &procEntry ) )
		return false;

	do
	{
		if( _tcscmp( procEntry.szExeFile, name ) == 0 )
			return true;
	}
	while( Process32Next( SnapShot, &procEntry ) );

	return false;
}
